#include	<windows.h>
#include	<COMDEF.H>
#include	<math.h>
#include	<new>
#include	<iostream>
using namespace std;
#include	"EpMathDLL.h"
#ifdef DEBUG_EPMATH
	#include	"common.h"
#endif

int *ErrCode;
HENSUU_DATA GLHensuu[40];				// ϐi[



//--------------------------------------------------------------------------
double KaisekiMain(char *, int *, int);

extern "C"
{
	void   DllExport EpM_Init();
	int    DllExport EpM_SetComand(char *, int);
	int    DllExport EpM_GetResult(char *, int *);
	double DllExport Kaiseki(char *, int *);
	DllExport double WINAPI Kaiseki_VB(char *, int *);
}



//--------------------------------------------------------------------------
// DllMain
// ƂɂꂪKv
//--------------------------------------------------------------------------
BOOL   WINAPI   DllMain (HANDLE hInst, 
                        ULONG ul_reason_for_call,
                        LPVOID lpReserved)
{
	switch( ul_reason_for_call){
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	default:
		break;
	}
	return TRUE;
}


//--------------------------------------------------------------------------
// vvZbT
// G[ɃG[R[hԂ
//--------------------------------------------------------------------------
int PriproCheck(char *mojiretu, MATH_GDATA *SetEpMath, int type)
{
extern	char *Tangoka(char *, char *);
extern	int  MojiHexToDec(char *);
extern	char *GetComand(char *,char *,int *,int,int);			// ̉Zq𐔒l
extern	int  CheckMathFunc(char *,int);					// Cu֐`FbN
extern	char *KazuKugiri(char *, char *);
	int  len = strlen(mojiretu)+1;
	int  ck;
	char *StartP = mojiretu;
	char *TmpBuff = new char[len];

	for(;*StartP;){
		memset(TmpBuff, '\0', len);				// 
		char *OrgP = StartP;
		StartP = Tangoka(StartP, TmpBuff);			// Pɕ
		if( *TmpBuff==' ' || *TmpBuff=='\t' || *TmpBuff=='\n')
			continue;
		if( ! kugirimoji(*TmpBuff) ){				// ؂蕶łȂ
			char *EndP;
			double result = strtod(OrgP, &EndP);		// 𕂓_ɕϊ
			if( !strncmp(TmpBuff,"0x",2) ){			// 0x
				SetEpMath->SetMath[SetEpMath->SetMathMax].data = MojiHexToDec(TmpBuff);	// 10iɕϊ
			}else if(EndP != OrgP){				// ɕϊłꍇ
				SetEpMath->SetMath[SetEpMath->SetMathMax].data = result;
				StartP = EndP;
			}else if( ck = CheckMathFunc(TmpBuff, type) ){	// yуCu֐`FbN
				SetEpMath->SetMath[SetEpMath->SetMathMax].Command = ck;
			}else{						// ERR
				memset(TmpBuff, '\0', len);
				StartP = KazuKugiri(OrgP, TmpBuff);
				ck = CheckMathFunc(TmpBuff, type);	// Cu֐`FbN
				if( type && ck ){
					// Basic ̏ꍇ 100Mod7 ̂悤ɊԂɋ󔒂Ă
					SetEpMath->SetMath[SetEpMath->SetMathMax].Command = ck;
				}else{
					if(TmpBuff[1] == '\0' || kugirimoji(TmpBuff[1]) ){
						if(TmpBuff[0] == 'L'){	// 10L̂悤ȕ\LɑΉ
							StartP = OrgP+1;
							continue;
						}
					}
#ifdef DEBUG_EPMATH
					cout << "1:sȕ = [" << CoutMask(TmpBuff) << "]" <<endl;
#endif
					delete[] TmpBuff;
					return ERR_MATH_MOJI;
				}
			}
		}else if( *TmpBuff == '\\' && *StartP == 'x' ){
			strcpy(TmpBuff, "0x");
			StartP++;
			StartP = Tangoka(StartP, (TmpBuff+2));
			SetEpMath->SetMath[SetEpMath->SetMathMax].data = MojiHexToDec(TmpBuff);	// 10iɕϊ
		}else{
			int GetCom;
			StartP = GetComand(TmpBuff, StartP, &GetCom, SetEpMath->SetMathMax, type);
			if( ! GetCom ){
#ifdef DEBUG_EPMATH
				cout << "1:sȕ = [" << CoutMask(TmpBuff) << "]" <<endl;
#endif
				delete[] TmpBuff;
				return ERR_MATH_MOJI;
			}
			SetEpMath->SetMath[SetEpMath->SetMathMax].Command = GetCom;
		}
		SetEpMath->SetMathMax++;
		if(SetEpMath->SetMathMax >= SetEpMath->SaveMax){
			int org = SetEpMath->SaveMax;
			SetEpMath->SaveMax += 20;
			MATH_DATA *NewMath = new MATH_DATA[SetEpMath->SaveMax];
			memset(NewMath, '\0', sizeof(MATH_DATA)*SetEpMath->SaveMax);
			memcpy(NewMath, SetEpMath->SetMath, sizeof(MATH_DATA)*org);
			delete[] SetEpMath->SetMath;
			SetEpMath->SetMath = NewMath;
		}
	}
	delete[] TmpBuff;
	return 0;
}

//--------------------------------------------------------------------------
// 
// f[^𐔒li[B
// ZqƐl͓Ɋi[ȂB
//--------------------------------------------------------------------------
void BunkaiDataInit(MATH_GDATA *SetEpMath)
{
	SetEpMath->SetMathMax = 0;
	SetEpMath->SaveMax = 20;
	SetEpMath->SetMath;

	SetEpMath->SetMath = new MATH_DATA[SetEpMath->SaveMax];
	memset(SetEpMath->SetMath, '\0',
		sizeof(MATH_DATA)*SetEpMath->SaveMax);

}


//--------------------------------------------------------------------------
// bp̓
//--------------------------------------------------------------------------
double DllExport Kaiseki(char *StartP, int *ErrBit)
{
	return KaisekiMain(StartP, ErrBit, 0);
}

//--------------------------------------------------------------------------
// uap̓
//--------------------------------------------------------------------------
DllExport double WINAPI Kaiseki_VB(char *StartP, int *ErrBit)
{
	return KaisekiMain(StartP, ErrBit, 1);
}

//--------------------------------------------------------------------------
// vZ̓e͂B
// #define REI    3+4  ----------@
// #define REI   (3+4) ----------A
// @AÂ悤ɒ`ĂꍇA
// #define SAMPLE  REI*3   ̒l͓ł͂Ȃ
// ()vvZbT֐̊֐̎gpOɎgB
//--------------------------------------------------------------------------
double KaisekiMain(char *StartP, int *ErrBit, int type)
{
extern	int KakkoCheck(char *, int *);
	double SetArg[2];
	int	kakko_max = 0;						// Kw̍ő吔
	int	kakko  = 0;						// ʂ̐
	*ErrBit = 0;							// 
	MATH_GDATA	SetEpMath;

	if(StartP == NULL || *StartP == '\0'){
		return 0;
	}

	if( KakkoCheck(StartP, &kakko_max) ){				// ʐERR
		*ErrBit = ERR_MATH_KAKKO;
		return 0;
	}

	BunkaiDataInit(&SetEpMath);

	if( *ErrBit = PriproCheck(StartP, &SetEpMath, type) ){		// G[R[h̑ƃ`FbN
		delete[] SetEpMath.SetMath;
		return 0;
	}

	ErrCode = ErrBit;
	EpMath	*EpObj;
	try{
		EpObj = new EpMath[kakko_max+1];			// IuWFNg̐
		for(int cc=0;cc<kakko_max+1;cc++){
			EpObj[cc].SetType(type);
		}
	}
	catch(std::bad_alloc){						// mۂł`FbN
		delete[] SetEpMath.SetMath;
		return ERR_MATH_MEMORY;
	}

	for(int a=0;a<SetEpMath.SetMathMax;a++){			// vZ̍Ō܂ŉ
		double	result = 0;
		if( SetEpMath.SetMath[a].Command ){
			int com = SetEpMath.SetMath[a].Command;

			if(com == LEVEL_KAKKO_B){			// ʂ̊Jn
				kakko++;
			}else if(com == LEVEL_KAKKO_A){			// ʂ̏I
				memset(SetArg, '\0', sizeof(SetArg));
				result = EpObj[kakko].GetResult(SetArg);	// ̊Kwł̌ʂ߂
				kakko--;				// Kwړ
				if(kakko < 0){
					*ErrBit = ERR_MATH_KAKKO;
					break;
				}
				EpObj[kakko].SetArgument(SetArg);	// argument擾
				EpObj[kakko].SetKazu(result);
			}else{
				EpObj[kakko].SetCommand(com);
			}
		}else{
			EpObj[kakko].SetKazu(SetEpMath.SetMath[a].data);
		}
	}

	double MathResult = EpObj[0].GetResult(SetArg);			// ŏʊKwɶωZq݂Ă

	delete[] SetEpMath.SetMath;
	delete[] EpObj;

	if( *ErrBit ){
		MathResult = 0;
#ifdef DEBUG_EPMATH
		cout << "ErrBit = [" << *ErrBit << "]" <<endl;
#endif
	}

	return MathResult;
}




//--------------------------------------------------------------------------
// RXgN^
//--------------------------------------------------------------------------
EpMath::EpMath()
{
	MaxDataCnt = 0;
	CommandIchi = 0;
	ComFlg = 0;
	ArguOn = 0;
	memset(argument, '\0', sizeof(argument));
	NewMathDataMax();			// Z[ü̍蒼

//	MathType = type;
}


//--------------------------------------------------------------------------
// fXgN^
//--------------------------------------------------------------------------
EpMath::~EpMath()
{
	delete[] MathData;
}

//--------------------------------------------------------------------------
// sB
// KwۂȂǂɎgp
//--------------------------------------------------------------------------
void EpMath::shyokika()
{
	CommandIchi = 0;
	ComFlg = 0;
	ArguOn = 0;
	memset(argument, '\0', sizeof(argument));
	memset(MathData, '\0', sizeof(MATH_DATA)*MaxDataCnt);
}

//--------------------------------------------------------------------------
// Z[ü̍蒼
//--------------------------------------------------------------------------
void EpMath::NewMathDataMax()
{
	int org_cnt = MaxDataCnt;
	MaxDataCnt += 10;

	MATH_DATA *NewData = new MATH_DATA[MaxDataCnt];
	memset(NewData, '\0', sizeof(MATH_DATA)*MaxDataCnt);

	if( org_cnt ){
		memcpy(NewData, MathData, sizeof(MATH_DATA)*org_cnt);
		delete[] MathData;
	}
	MathData = NewData;
}
//--------------------------------------------------------------------------
// ^Cvݒ
//--------------------------------------------------------------------------
void EpMath::SetType(int type)
{
	MathType = type;
}
//--------------------------------------------------------------------------
// R}hۑB
// {IɁulAR}hvƂԂɂȂB
//--------------------------------------------------------------------------
void EpMath::SetCommand(int com)
{
	if( ComFlg ){
		CommandIchi++;
		if(CommandIchi >= MaxDataCnt){			// Z[ü悪ȂȂ
			NewMathDataMax();			// Z[ü̍蒼
		}
		switch(MathType){
		case 0:
			if(MathData[CommandIchi-1].Command == LEVEL_MINUS){
				MathData[CommandIchi].fugou = 1;
			}
			break;
		case 1:
			if(MathData[CommandIchi-1].Command == LEVEL_VB_MINUS){
				MathData[CommandIchi].fugou = 1;
			}
			break;
		default:
			break;
		}
	}
	ComFlg++;

	MathData[CommandIchi].Command = com;
}


//--------------------------------------------------------------------------
// l̓
// vZ͑ỎZqȂƌvZ鎖͏oȂ̂
// ͈ʒu2ȏ̏ꍇ̂ݎsĂB
//--------------------------------------------------------------------------
void EpMath::SetKazu(double kazu)
{
	switch(MathType){
	case 0:
		if(MathData[CommandIchi].Command == LEVEL_MINUS){
			kazu *= -1;
			if(CommandIchi-1 >= 0){
				int Com = MathData[CommandIchi-1].Command;
				// ZqAĂꍇ
				if(ComFlg > 1){
					if(Com == LEVEL_ASTA || Com == LEVEL_THRA || Com ==LEVEL_PAR){
						MathData[CommandIchi].Command = 0;
						CommandIchi--;
					}
				}
			}
		}
		break;
	case 1:
		if(MathData[CommandIchi].Command == LEVEL_VB_MINUS){
			kazu *= -1;
			if(CommandIchi-1 >= 0){
				int Com = MathData[CommandIchi-1].Command;
				// ZqAĂꍇ
				if(ComFlg > 1){
					if(Com == LEVEL_VB_JYOU || Com == LEVEL_VB_ASTA || 
					   Com == LEVEL_VB_THRA || Com == LEVEL_VB_SHOW ||
					   Com == LEVEL_VB_REST){
						MathData[CommandIchi].Command = 0;
						CommandIchi--;
					}
				}
			}
		}
		break;
	default:
		break;
	}
	ComFlg = 0;
	if( kazu || ! ArguOn ){					// argumentΉ
		MathData[CommandIchi].data = kazu;
	}
	ArguOn = 0;
	CommandIchi++;						// ͈ʒuύX

	if(CommandIchi >= MaxDataCnt){				// Z[ü悪ȂȂ
		NewMathDataMax();				// Z[ü̍蒼
	}

	// D揇ʂ𔻒肵AvZĂǂ
	// ̕vZB(E̗D揇ʂႯΌvZ)
	RunJuni(ST_RUN);
}


//--------------------------------------------------------------------------
// vZʂ߂B
// ʂɂKw̎lďgpϐ
// B
//--------------------------------------------------------------------------
double EpMath::GetResult(double *SetArg)
{

#ifdef DEBUG_EPMATH					// R}hƓ͐l̊mFp(debug)
	for(int cc=0;cc<MaxDataCnt;cc++){
		cout << MathData[cc].Command << ":";
		cout << MathData[cc].data << "," ;
	}
	cout << endl;
#endif

	if(MathData[CommandIchi].Command == 0){		// ݓ͂ĂʒuɒB
		CommandIchi--;
	}

	RunJuni(ST_END);				// Zq̗D揇ʂ̕ӏs

	double mae=0,ato=0;

	for(int a=CommandIchi;a>0;a--){			// E̕D揇ʂȂĂ̂
		switch(MathType){
		case 0:
			switch( MathData[a].Command ){
			case LEVEL_KORON:			// ':'
				ato = MathData[a].data;
				mae = MathData[a-1].data;
				MathData[a].data = 0;
				MathData[a].Command = 0;
				break;
			case LEVEL_HATENA:			// '?'
				if( MathData[a-1].data )	// ^̏ꍇ
					MathData[a-1].data = mae;
				else				// Ȕꍇ
					MathData[a-1].data = ato;
				MathData[a].data = 0;
				MathData[a].Command = 0;
				break;
			default:
				MathData[a-1].data = EnzanHantei(a, ErrCode);
				break;
			}
			break;
		case 1:
			MathData[a-1].data = EnzanHantei(a, ErrCode);
			break;
		default:
			break;
		}
	}

	double MathResult = MathData[0].data;

	SetArg[0] = argument[0];			// ̎擾
	SetArg[1] = argument[1];

	shyokika();					// 

	return MathResult;
}

//--------------------------------------------------------------------------
// argumentĂ
//--------------------------------------------------------------------------
void	EpMath::SetArgument(double GetData[2])
{
	if( GetData[0] ){
		MathData[CommandIchi].data  = GetData[0];
		ArguOn = 1;				// argumentď
	}
	if( GetData[1] ){
		MathData[CommandIchi].data2 = GetData[1];
		ArguOn = 1;				// argumentď
	}
}

//--------------------------------------------------------------------------
// vZ̎s
// Zq̗D揇ʂāAɂ鉉Zq̏ʂ
// ΁AvZsB
//--------------------------------------------------------------------------
void EpMath::RunJuni(int mode)
{
	if(mode != ST_END){
		if( CommandIchi==1 || CommandIchi==2 ){		// ichi͂̒OɃCNgĂB
			return;
		}
	}

	while(1){						// [v
		int henka = 0;					// ω邩ǂ`FbN
		for(int a=0;(a+1)<MaxDataCnt;a++){
			if(MathData[a+1].Command == 0){
				if( MathData[a+1].data ){
#ifdef DEBUG_EPMATH
					cerr << "1:Ɍ肪܂B" << endl;
#endif
					*ErrCode = ERR_MATH_SHIKI;
				}
				break;
			}
			if( a==0 && MathData[0].Command==0 )
				continue;
			if(MathData[a].Command <= MathData[a+1].Command){	// ̕D揇ʂ
				if( a==0 && MathData[a+1].Command != 0 ){
					MathData[0].data = FirstEnzanshiHantei(ErrCode);
					MathData[0].Command = 0;
					break;
				}
				MathData[a-1].data = EnzanHantei(a, ErrCode);
				int b;
				for(b=a;b+1<MaxDataCnt;b++){
					if(MathData[b].Command == 0)
						break;
					memcpy(&MathData[b], &MathData[b+1], sizeof(MATH_DATA));
				}
				memset( &MathData[b-1], '\0', sizeof(MATH_DATA));
				CommandIchi--;			// ͈ʒuύX
				henka = 1;			// ω
				break;
			}
		}
		if( ! henka )
			break;
	}
	if(mode == ST_END){					// vZI̓ʏ
		if(MathData[0].Command != 0){			// r̂ȂƌvZłȂ̂
			MathData[0].data = FirstEnzanshiHantei(ErrCode);
			MathData[0].Command = 0;
		}
	}

}


//--------------------------------------------------------------------------
// Zq̏(TOP)
// ̈ԍŏɂꍇ(ꏈ)
//--------------------------------------------------------------------------
double EpMath::FirstEnzanshiHantei(int *ErrBit)
{
	if(MathType == 0){
		return FirstEnzanshiHantei_C(ErrBit);
	}else{
		return FirstEnzanshiHantei_B(ErrBit);
	}

	return 0;
}

//--------------------------------------------------------------------------
// Zq̏(TOP)
//--------------------------------------------------------------------------
double EpMath::EnzanHantei(int Ichi, int *ErrBit)
{
	if(MathType == 0){
		return EnzanHantei_C(Ichi, ErrBit);
	}else{
		return EnzanHantei_B(Ichi, ErrBit);
	}
	return 0;
}

//--------------------------------------------------------------------------
// Zq̏
// ̈ԍŏɂꍇ(ꏈ)
//--------------------------------------------------------------------------
double EpMath::FirstEnzanshiHantei_C(int *ErrBit)
{
	double Ax = MathData[0].data;
	int AxInt = (int)MathData[0].data;

	switch( MathData[0].Command ){
	case LEVEL_PULAS:				// '+'
		return Ax;
	case LEVEL_PULAS2:				// "++"
		return (Ax+1);
	case LEVEL_MINUS:				// '-'
//		return (-Ax);
		return Ax;
	case LEVEL_MINUS2:				// "--"
		return (Ax-1);
	case LEVEL_MATIRUDA:				// '~'
		return (~AxInt);
	case LEVEL_NOT:					// '!'
		if( Ax )
			return 0;
		else
			return 1;
	case LEVEL_KANMA:				// ',' 
		argument[0] = MathData[0].data;
		argument[1] = MathData[1].data;
		return 0;
	case LEVEL_ACOS:				// acos() 
		return acos(Ax);
	case LEVEL_ASIN:				// asin() 
		return asin(Ax);
	case LEVEL_ATAN:				// atan() 
		return atan(Ax);
	case LEVEL_ATAN2:				// atan2(,) 
		return atan2(MathData[0].data, MathData[0].data2);
	case LEVEL_COS:					// cos() 
		return cos(Ax);
	case LEVEL_SIN:					// sin() 
		return sin(Ax);
	case LEVEL_TAN:					// tan() 
		return tan(Ax);
	case LEVEL_COSH:				// cosh() 
		return cosh(Ax);
	case LEVEL_SINH:				// sinh() 
		return sinh(Ax);
	case LEVEL_TANH:				// tanh() 
		return tanh(Ax);
	case LEVEL_EXP:					// exp() 
		return exp(Ax);
//	case LEVEL_FREXP:				// frexp(,)
	case LEVEL_LDEXP:				// ldexp(,)
		return ldexp(MathData[0].data, (int)MathData[0].data2);
	case LEVEL_ABS:					// abs() 
		return abs(AxInt);
	case LEVEL_LABS:				// labs() 
		return labs(AxInt);
	case LEVEL_LOG:					// log() 
		return log(Ax);
	case LEVEL_LOG10:				// log10() 
		return log10(Ax);
//	case LEVEL_MODF:				// modf(,)
	case LEVEL_POW:					// pow(,)
		return pow(MathData[0].data, MathData[0].data2);
	case LEVEL_SQRT:				// sqrt()
		if( Ax < 0 ){
#ifdef DEBUG_EPMATH
			cerr << "5:Ɍ肪܂B" << endl;
#endif
			*ErrBit = ERR_MATH_SHIKI;
			break;
		}
		return sqrt(Ax);
	case LEVEL_CEIL:				// ceil()
		return ceil(Ax);
	case LEVEL_FLOOR:				// floor()
		return floor(Ax);
	case LEVEL_FMOD:				// fmod(,)
		return fmod(MathData[0].data, MathData[0].data2);
	default:						// ŋ̂͏L̂
		break;
	}

	return 0;
}


//--------------------------------------------------------------------------
// Zq̏
// {Iɂ̊֐gꍇAR}hlR}hƂȂB
// Ƃ"5+3+++4"Ƃ͎̂悤ɕ\B
// l+++l     (FR}h Fl)
//--------------------------------------------------------------------------
double EpMath::EnzanHantei_C(int Ichi, int *ErrBit)
{
	double GetAx = MathData[Ichi-1].data;
	double GetBx = MathData[Ichi].data;
	double result= 0;
	int AxInt = (int)GetAx;
	int BxInt = (int)GetBx;

	switch( MathData[Ichi].Command ){
	case LEVEL_PULAS:				// '+'
		return ( GetAx + GetBx );
	case LEVEL_MINUS:				// '-'
//		return ( GetAx - GetBx );
		if( MathData[Ichi].fugou ){		// ]
			GetBx *= -1;
		}
		return ( GetAx + GetBx );
	case LEVEL_ASTA:				// '*'
		return ( GetAx * GetBx );
	case LEVEL_THRA:				// '/'
		if( ! GetBx ){
			*ErrBit = ERR_MATH_ZERO;
			break;
		}
		return ( GetAx / GetBx);
	case LEVEL_PAR:					// '%'
		if( ! BxInt ){
			*ErrBit = ERR_MATH_ZERO;
			break;
		}
		return ( AxInt % BxInt );
	case LEVEL_DOWN:				// '>' s
		if( GetAx > GetBx )
			return 1;
		break;
	case LEVEL_UP:					// '<' s
		if( GetAx < GetBx )
			return 1;
		break;
	case LEVEL_BIT_AND:				// '&' rbgZ(AND)
		return (AxInt & BxInt);
	case LEVEL_BIT_OR:				// '|' rbgZ(OR)
		return (AxInt | BxInt);
	case LEVEL_BIT_XOR:				// '^' rI_a
		return (AxInt ^ BxInt);
	case LEVEL_MATIRUDA:				// "~"̑Oɂ͐l͗Ȃ
		return (~BxInt);
	case LEVEL_NOT:					// "!"̑Oɂ͐l͗Ȃ
		if( GetBx )
			return 0;
		else
			return 1;
	case LEVEL_KANMA:				// ',' 
		argument[0] = GetAx;
		argument[1] = GetBx;
		return 0;
	case LEVEL_ICOAL:				// "==" 
		if( GetAx == GetBx )
			return 1;
		break;
	case LEVEL_DOWN_ICOAL:				// ">=" ȉ
		if( GetAx >= GetBx )
			return 1;
		break;
	case LEVEL_UP_ICOAL:				// "<=" ȏ
		if( GetAx <= GetBx )
			return 1;
		break;
	case LEVEL_AND:					// "&&" AND
		if( GetAx && GetBx )
			return 1;
		break;
	case LEVEL_OR:					// "||" OR
		if( GetAx || GetBx )
			return 1;
		break;
	case LEVEL_SHIFT_UP:				// "<<" ĉZ
		return (AxInt <<= BxInt);
	case LEVEL_SHIFT_DOWN:				// ">>" ĉZ
		return (AxInt >>= BxInt);
	case LEVEL_PULAS_IN:				// "+="
		return (GetAx += GetBx);
	case LEVEL_MINUS_IN:				// "-="
		return (GetAx -= GetBx);
	case LEVEL_ASTA_IN:				// "*="
		return (GetAx *= GetBx);
	case LEVEL_THRA_IN:				// "/="
		if( ! GetBx ){
			*ErrBit = ERR_MATH_ZERO;
			break;
		}
		return (GetAx /= GetBx);
	case LEVEL_PAR_IN:				// "%="
		if( ! BxInt ){
			*ErrBit = ERR_MATH_ZERO;
			break;
		}
		return (AxInt % BxInt);
	case LEVEL_DOWN_IN:				// ">>="
		return (AxInt >>= BxInt);
	case LEVEL_UP_IN:				// "<<="
		return (AxInt <<= BxInt);
	case LEVEL_ADN_IN:				// "&="
		return (AxInt &= BxInt);
	case LEVEL_XOR_IN:				// "^="
		return (AxInt ^= BxInt);
	case LEVEL_OR_IN:				// "|="
		return (AxInt |= BxInt);
	case LEVEL_NOT_ICOAL:				// "!="
		if(GetAx == GetBx)
			return 0;
		else
			return 1;
	case LEVEL_PULAS2:				// "++"
		// ++Ƃ͂̂ǂ炩0ƂȂĂ͂Ȃ̂
		if( GetAx!=0 && GetBx!=0 ){
#ifdef DEBUG_EPMATH
			cerr << "3:Ɍ肪܂B" << endl;
#endif
			*ErrBit = ERR_MATH_SHIKI;
			break;
		}
		return (GetAx+GetBx+1);
	case LEVEL_MINUS2:				// "--"
		if( GetAx!=0 && GetBx!=0 ){
#ifdef DEBUG_EPMATH
			cerr << "4:Ɍ肪܂B" << endl;
#endif
			*ErrBit = ERR_MATH_SHIKI;
			break;
		}
		return (GetAx+GetBx-1);
	//----------------------------------------------------------
	case LEVEL_ACOS:				// acos() 
		result = acos(GetBx);
		break;
	case LEVEL_ASIN:				// asin() 
		result = asin(GetBx);
		break;
	case LEVEL_ATAN:				// atan() 
		result = atan(GetBx);
		break;
	case LEVEL_ATAN2:				// atan2(,) 
		result = atan2(MathData[Ichi].data, MathData[Ichi].data2);
		break;
	case LEVEL_COS:					// cos() 
		result = cos(GetBx);
		break;
	case LEVEL_SIN:					// sin() 
		result = sin(GetBx);
		break;
	case LEVEL_TAN:					// tan() 
		result = tan(GetBx);
		break;
	case LEVEL_COSH:				// cosh() 
		result = cosh(GetBx);
		break;
	case LEVEL_SINH:				// sinh() 
		result = sinh(GetBx);
		break;
	case LEVEL_TANH:				// tanh() 
		result = tanh(GetBx);
		break;
	case LEVEL_EXP:					// exp() 
		result = exp(GetBx);
		break;
//	case LEVEL_FREXP:				// frexp(,)
	case LEVEL_LDEXP:				// ldexp(,)
		result = ldexp(MathData[Ichi].data, (int)MathData[Ichi].data2);
		break;
	case LEVEL_ABS:					// abs() 
		result = abs(BxInt);
		break;
	case LEVEL_LABS:				// labs() 
		result = labs(BxInt);
		break;
	case LEVEL_LOG:					// log() 
		result = log(GetBx);
		break;
	case LEVEL_LOG10:				// log10() 
		result = log10(GetBx);
		break;
//	case LEVEL_MODF:				// modf(,)
	case LEVEL_POW:					// pow(,)
		result = pow(MathData[Ichi].data, MathData[Ichi].data2);
		break;
	case LEVEL_SQRT:				// sqrt() ߂
		if( GetBx < 0 ){
#ifdef DEBUG_EPMATH
			cerr << "5:Ɍ肪܂B" << endl;
#endif
			*ErrBit = ERR_MATH_SHIKI;
			break;
		}
		result = sqrt(GetBx);
		break;
	case LEVEL_CEIL:				// ceil()
		result = ceil(GetBx);
		break;
	case LEVEL_FLOOR:				// floor()
		result = floor(GetBx);
		break;
	case LEVEL_FMOD:				// fmod(,)
		result = fmod(MathData[Ichi].data, MathData[Ichi].data2);
		break;
	default:
#ifdef DEBUG_EPMATH
		cerr << "6:Ɍ肪܂B" << endl;
		cerr << "GetAx = [" << GetAx << "]  ";
		cerr << "GetBx = [" << GetBx << "]  ";
		cerr << "jyoken= [" << MathData[Ichi].Command << "]" << endl;
#endif
		*ErrBit = ERR_MATH_SHIKI;
		break;
	}

	if( MathData[Ichi].fugou ){			// Zp֐̏ꍇ͂ŕ]
		result *= -1;
	}

	return result;
}

//--------------------------------------------------------------------------
// Zq̏
// ̈ԍŏɂꍇ(ꏈ)
//--------------------------------------------------------------------------
double EpMath::FirstEnzanshiHantei_B(int *ErrBit)
{
	double Ax = MathData[0].data;
	int AxInt = (int)MathData[0].data;

	switch( MathData[0].Command ){
	case LEVEL_VB_ABS:				// abs() Βl߂
		return abs(AxInt);
	case LEVEL_VB_ATN:				// atn()
		return atan(Ax);
	case LEVEL_VB_COS:				// cos()
		return cos(Ax);
	case LEVEL_VB_EXP:				// exp()
		return exp(Ax);
	case LEVLE_VB_FIX:				// fix() Ԃ
		return AxInt;
	case LEVEL_VB_INT:				// int() Ԃ -8.8  -9
		if(AxInt > Ax){				// ̐ɂȂĂ
			return AxInt-1;
		}else{
			return AxInt;
		}
		break;
	case LEVEL_VB_LOG:				// log()
		return log(Ax);
	case LEVEL_VB_SIN:				// sin()
		return sin(Ax);
	case LEVEL_VB_SQR:				// sqr() ߂
		if( Ax < 0 ){
#ifdef DEBUG_EPMATH
			cerr << "5:Ɍ肪܂(VB)B" << endl;
#endif
			*ErrBit = ERR_MATH_SHIKI;
			break;
		}
		return sqrt(Ax);
	case LEVEL_VB_TAN:				// tan()
		return tan(Ax);
	//-----------------------------------------
	case LEVEL_VB_PULAS:				// '+'
		return Ax;
	case LEVEL_VB_MINUS:				// '-'
		return Ax;
	case LEVEL_VB_NOT:				// "!"
		if( AxInt )
			return 0;
		else
			return 1;
	default:					// ŋ̂͏L̂
		break;
	}

	return 0;
}


//--------------------------------------------------------------------------
// Zq̏
// {Iɂ̊֐gꍇAR}hlR}hƂȂB
// Ƃ"5+3+++4"Ƃ͎̂悤ɕ\B
// l+++l     (FR}h Fl)
//--------------------------------------------------------------------------
double EpMath::EnzanHantei_B(int Ichi, int *ErrBit)
{
	double GetAx = MathData[Ichi-1].data;
	double GetBx = MathData[Ichi].data;
	double result= 0;
	int AxInt = (int)GetAx;
	int BxInt = (int)GetBx;

	switch( MathData[Ichi].Command ){
	case LEVEL_VB_ABS:				// abs() Βl߂
		result = abs(BxInt);
		break;
	case LEVEL_VB_ATN:				// atn()
		result = atan(GetBx);
		break;
	case LEVEL_VB_COS:				// cos()
		result = cos(GetBx);
		break;
	case LEVEL_VB_EXP:				// exp()
		result = exp(GetBx);
		break;
	case LEVLE_VB_FIX:				// fix() Ԃ
		result = BxInt;
		break;
	case LEVEL_VB_INT:				// int() Ԃ -8.8  -9
		if(BxInt > GetBx){			// ̐ɂȂĂ
			result = BxInt-1;
		}else{
			result = BxInt;
		}
		break;
	case LEVEL_VB_LOG:				// log()
		result = log(GetBx);
		break;
	case LEVEL_VB_SIN:				// sin()
		result = sin(GetBx);
		break;
	case LEVEL_VB_SQR:				// sqr() ߂
		if( GetBx < 0 ){
#ifdef DEBUG_EPMATH
			cerr << "5:Ɍ肪܂(VB)B" << endl;
#endif
			*ErrBit = ERR_MATH_SHIKI;
			break;
		}
		result = sqrt(GetBx);
		break;
	case LEVEL_VB_TAN:				// tan()
		result = tan(GetBx);
		break;
	//-----------------------------------------
	case LEVEL_VB_JYOU:				// ^ (搔)
		result = pow(GetAx, GetBx);
		break;
	case LEVEL_VB_ASTA:				// '*'
		return ( GetAx * GetBx );
	case LEVEL_VB_THRA:				// '/'
		if( ! GetBx ){
			*ErrBit = ERR_MATH_ZERO;
			break;
		}
		return ( GetAx / GetBx);
	case LEVEL_VB_SHOW:				// \ ()
		if( ! BxInt ){
			if(MathData[Ichi+1].Command == LEVEL_VB_SHOW){
				*ErrBit = ERR_MATH_SHIKI;
			}else{
				*ErrBit = ERR_MATH_ZERO;
			}
			break;
		}
		return ( (int)(AxInt / BxInt) );
	case LEVEL_VB_REST:				// Mod (܂)
		if( ! BxInt ){
			*ErrBit = ERR_MATH_ZERO;
			break;
		}
		return ( AxInt % BxInt );
	case LEVEL_VB_PULAS:				// '+'
		return ( GetAx + GetBx );
	case LEVEL_VB_MINUS:				// '-'
		if( MathData[Ichi].fugou ){		// ]
			GetBx *= -1;
		}
		return ( GetAx + GetBx );
	case LEVEL_VB_ICOAL:				// "=" 
		if( GetAx==GetBx )
			return 1;
		break;
	case LEVEL_VB_NOT_ICOAL:			// "<>"Ȃ
		if( GetAx == GetBx )
			return 0;
		else
			return 1;
	case LEVEL_VB_UP:				// '<' s
		if( GetAx < GetBx )
			return 1;
		break;
	case LEVEL_VB_DOWN:				// '>' s
		if( GetAx > GetBx )
			return 1;
		break;
	case LEVEL_VB_UP_ICOAL:				// "<=" ȏ
		if( GetAx <= GetBx )
			return 1;
		break;
	case LEVEL_VB_DOWN_ICOAL:			// ">=" ȉ
		if( GetAx >= GetBx )
			return 1;
		break;
	case LEVEL_VB_NOT:					// "!"
		if( GetBx )
			return 0;
		else
			return 1;
	case LEVEL_VB_AND:				// & (And)
		return (AxInt & BxInt);
	case LEVEL_VB_OR:				// | (Or)
		return (AxInt | BxInt);
	case LEVEL_VB_XOR:				// ^ (Xor)
		return (AxInt ^ BxInt);
	case LEVEL_VB_EQV:				// (Eqv) 2̘̎_Z
		if( GetAx && GetBx )
			return 1;
		if( ! GetAx && ! GetBx )
			return 1;
		break;
	case LEVEL_VB_IMP:				// (Imp) 2̘̎_܉Z
		if( GetAx && GetBx )
			return 1;
		if( ! GetAx && ! GetBx )
			return 1;
		break;
	default:
#ifdef DEBUG_EPMATH
		cerr << "7:Ɍ肪܂(VB)B" << endl;
		cerr << "GetAx = [" << GetAx << "]  ";
		cerr << "GetBx = [" << GetBx << "]  ";
		cerr << "jyoken= [" << MathData[Ichi].Command << "]" << endl;
#endif
		*ErrBit = ERR_MATH_SHIKI;
		break;
	}

	if( MathData[Ichi].fugou ){			// Zp֐̏ꍇ͂ŕ]
		result *= -1;
	}

	return result;
}

